// Lista2.cpp : Defines the entry point for the console application.
//

// OBSERVAO, no deixe de olhar o stdafx.h
#include "stdafx.h"

// Cabealho para a funo 'genrica' capaz de imprimir uma lista.
template <class T>
void printList( const std::list<T> &listRef );

// Funo main pr-criada na criao de projeto Win32 console no Express Edition.
int _tmain(int argc, _TCHAR* argv[])
{
		// Define uma constante;
    const int SIZE = 4;

	// Define um vetor, inicializando-o;
	int a[ SIZE ] = { 2, 6, 4, 8 };

	// Define duas lista a partir da classe 'list' do STL (Standard Template Library)
	// A 'list' do STL  um template e aqui este template  
	// parametrizado com a classe 'int'.
	std::list<int> valores, outrosValores;

	// *************************************************
	// Adiciona elementos a lista a partir de seu comeo.
	valores.push_front( 1 );
	valores.push_front( 2 );
	// Adiciona elementos a lista a partir de seu fim.
	valores.push_back ( 4 );
	valores.push_back ( 3 );

	// Imprime os elementos da lista via a funo printList().
	cout << "Values contm: "; printList( valores ); cout << endl;
	
	// *************************************************
	// Ordena os elementos da lista.
	valores.sort();
	// Imprime os elementos da lista via a funo printList().
	cout << "Values aps o 'sort' contm: "; printList( valores ); cout << endl;

	// SEGUNDA VERSO A PARTIR DAQUI
	// *************************************************
	// Insere valores em others Values...
	outrosValores.insert( outrosValores.begin(), a, a + SIZE);
	cout << "Othervalues contm: "; printList( outrosValores ); cout << endl;

	valores.splice( valores.end(), outrosValores);
	cout << "Aps splice values contm: "; printList( valores ); cout << endl;
	cout << "Aps splice otherValues contm: "; printList( outrosValores ); cout << endl;

	// *************************************************
	valores.sort();
	cout << "Values aps o 'sort' contm: "; printList( valores ); cout << endl << endl;

    outrosValores.insert( outrosValores.begin(), a, a + SIZE);
	outrosValores.sort();

	cout << "Othervalues contm: "; printList( outrosValores ); cout << endl;

	valores.merge( outrosValores );
	cout << "Aps merge values contm: "; printList( valores ); cout << endl;
	cout << "Aps merge otherValues contm: "; printList( outrosValores ); cout << endl;

    // *************************************************
	valores.pop_front();
	valores.pop_back();     // todos os conteineres sequenciais.  O que seria um conteiner? (Vide livro do Deitel...)
	cout << "Aps pop_front e pop_merge values contm: "; printList( valores ); cout << endl;

	// *************************************************
	valores.unique();
	cout << "Aps unique values contm: "; printList( valores ); cout << endl << endl;

	//otherValues.insert( otherValues.begin(), a, a + SIZE);
	//otherValues.sort();
	//cout << "**** Othervalues contm: "; printList( otherValues ); cout << endl;
		
	// *************************************************
	valores.swap( outrosValores );
	cout << "Aps swap values contm: "; printList( valores ); // cout << endl;
	cout << "Aps swap otherValues contm: "; printList( outrosValores ); cout << endl << endl;

	// *************************************************
	valores.assign( outrosValores.begin(), outrosValores.end() );
	cout << "Aps assign values contm: "; printList( valores ); cout << endl;
	cout << "Aps assign otherValues contm: "; printList( outrosValores ); cout << endl;

	// *************************************************
	valores.merge( outrosValores );
	cout << "Aps merge values contm: "; printList( valores ); cout << endl;
	cout << "Aps merge otherValues contm: "; printList( outrosValores ); cout << endl;

	// *************************************************
	valores.remove( 4 );
	cout << "Aps merge values contm: "; printList( valores ); cout << endl;
		
	return 0;
}

// Implementao da funo genrica capaz de imprimir uma lista
template <class T>
void printList( const std::list<T> &listRef )
{
	// Testa se a lista est vazia.
    if ( listRef.empty() )
	{
		cout << "Lista est vazia." << endl;
	}
	else
	{
		// Cria um iterado, isto , um objeto que  capaz de receber
		// um 'ponteiro inicial' e um 'ponteiro final' de uma lista e,
		// a partir da, imprimir todos os elementos da lista.

		// O interador exige um objeto de sada... Neste caso
		// usamos o cout que, na verdade,  um objeto denido em <stream>
		// Ainda, pode-se adicionar um texto entre cada elemento impresso.

		std::ostream_iterator< T > Saida ( cout, " " );

		// Este comando o interador Saida receber o 'ponteiro inicial'
		// bem como o 'ponteiro final'.
		std::copy( listRef.begin(), listRef.end(), Saida );
	}
}


